----------------------------------------------------------------------------------
-- Create Date:    16:55:50 10/03/2012 
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

entity debouncing_circuits is
    Port ( clk       : in   STD_LOGIC;
           reset     : in   STD_LOGIC;
           sw        : in   STD_LOGIC;
           sw1       : in   STD_LOGIC;
           sw2       : in   STD_LOGIC;
           sw3       : in   STD_LOGIC;
           sw4       : in   STD_LOGIC;
           sw5       : in   STD_LOGIC;
           btn       : in   STD_LOGIC;
           btn1      : in   STD_LOGIC;
           btn2      : in   STD_LOGIC;
           btn3      : in   STD_LOGIC;
           sw_level  : out  STD_LOGIC;
           sw1_level : out  STD_LOGIC;
           sw2_level : out  STD_LOGIC;
           sw3_level : out  STD_LOGIC;
           sw4_level : out  STD_LOGIC;
           sw5_level : out  STD_LOGIC;
           btn_tick  : out  STD_LOGIC;
           btn1_tick : out  STD_LOGIC;
           btn2_tick : out  STD_LOGIC;
           btn3_tick : out  STD_LOGIC);
end debouncing_circuits;

architecture Behavioral of debouncing_circuits is

begin
sw_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw, db_tick=>open, db_level=>sw_level);   
            
sw1_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw1, db_tick=>open, db_level=>sw1_level);
            
sw2_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw2, db_tick=>open, db_level=>sw2_level); 

sw3_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw3, db_tick=>open, db_level=>sw3_level);    

sw4_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw4, db_tick=>open, db_level=>sw4_level); 

sw5_unit: entity work.debounce(behavioral)
        port map (
            clk=>clk, reset=>reset, btn_sw=>sw5, db_tick=>open, db_level=>sw5_level); 

btn_unit: entity work.debounce(behavioral)
        port map (
            clk => clk, reset=>reset, btn_sw=>btn, db_tick=>btn_tick, db_level=>open
        ); 

btn1_unit: entity work.debounce(behavioral)
        port map (
            clk => clk, reset=>reset, btn_sw=>btn1, db_tick=>btn1_tick, db_level=>open
        ); 

btn2_unit: entity work.debounce(behavioral)
        port map (
            clk => clk, reset=>reset, btn_sw=>btn2, db_tick=>btn2_tick, db_level=>open
        ); 

btn3_unit: entity work.debounce(behavioral)
        port map (
            clk => clk, reset=>reset, btn_sw=>btn3, db_tick=>btn3_tick, db_level=>open
        );         

end Behavioral;

